/*
	MR/2 ICE - PMM2XCVT.CMD

	Copyright (c) 1996,2004 Nick Knight
	All Rights Reserved.

	Author: 	Nick Knight
	Created:	10/23/96
	Updated:	11/21/2004
	Usage:		pmm2Xcvt (no parameters)

	Purpose:	pmm2Xcvt.cmd allows for the conversion or "migration"
				of an existing PM Mail v2.X install to MR/2 ICE format.
				Options include migrating the address books AND/OR the
				message/folder system. Must be invoked from within the
				base "BSW-INC" directory, but then, the script will
				inform you of this :).

	US Mail:	Nick Knight, PO Box 29076, Parma, Ohio 44129
	Internet:	nick@mr2ice.com

*/

'@echo off'

/************************************************/
/*	YOU MUST EDIT AND SET THESE THREE VARIABLES */
/************************************************/

ACCT = '????_SE1.ACT'
MR2PATH = '?:\mr2i'

/************************************************/
/* This variable should be set to migrate into	*/
/* a secondary MR/2 ICE account 				*/
/************************************************/

MR2ACCOUNT = 'mail'

/************************************************/
/* edit the lines above as desired				*/
/************************************************/

RealNameInQuotes = 0
ConvertFolders = 0
ConvertAddressBooks = 0

MakeUpAliases = 1
MR2ACCTPATH = MR2PATH'\'MR2ACCOUNT

'Set beginlibpath='MR2PATH

Say ''
Say 'MR/2 ICE Conversion Utility (from PMM v2.x) v2.0'
Say 'Copyright (c) Knightware Software Company, 1996,2004'
Say 'All Rights Reserved.'
Say ''

if stream('tools\addr.db','c','query exists') = "" then do
	Say 'Sorry, you must run this script from within the PM Mail root directory.'
	Say 'If you do a directory list, "TOOLS" should be a subdirectory.'
	Say ''
	exit
end

if stream(MR2PATH'\mr2i.exe','c','query exists') = "" then do
	Say 'The internal REXX variable MR2PATH does not appear to'
	Say 'identify a valid MR/2 ICE directory.  There are paths and option'
	Say 'values at the top of this script that must be configured by the'
	Say 'user.  Please edit this script file and follow the simple'
	Say 'directions at the top.'
	Say ' '
	Say 'The value of MR2PATH is currently set to "'MR2PATH'".'
	Say ' '
	exit
end

if stream('pmmail\'ACCT'\ACCT.ini','c','query exists') = "" then do
	Say 'The internal REXX variable ACCT does not appear to identify'
	Say 'a valid PMMAIL account.  There are paths and option values at'
	Say 'the top of this script that must be configured by the user.'
	Say 'Please edit this script file and follow the simple directions'
	Say 'at the top.'
	Say ' '
	Say 'The value of ACCT is currently set to "'ACCT'".'
	Say ''
	Say 'Valid PMMail accounts are:'
	Say ' '
	'dir pmmail\*.act /B'
	Say ''
	exit
end

Say ''
Say 'You are converting INTO the MR/2 ICE account of "'MR2ACCOUNT'".'
if MR2ACCOUNT = 'mail' then
	Say '    (This is the default single-user account for MR/2 ICE)'
Say ''
Say ''

fOK = 0
do while fOK = 0
	Say 'Conversion options are:'
	Say ''
	Say '    1 - Convert both address books and messages (folders)'
	Say '    2 - Convert address books only'
	Say '    3 - Convert messages (folders) only'
	Say ''
	Say 'Please select your preference by entering 1,2 or 3 and ENTER:'
	choice = linein()
	Say ''
	if choice = 1 then do
		ConvertFolders = 1
		ConvertAddressBooks = 1
		fOK = 1
	end
	else if choice = 2 then do
		ConvertAddressBooks = 1
		fOK = 1
	end
	else if choice = 3 then do
		ConvertFolders = 1
		fOK = 1
	end
	else do
		Say ''
		Say 'Invalid selection!  Please select a 1,2 or 3, or CTR-C to abort.'
		Say ''
		Say ''
	end
end

'cd >basedir.lst'
basedir = linein('basedir.lst')
rc = stream('basedir.lst','c','close')

if ConvertAddressBooks == 1 then do

	if stream(MR2PATH'\mr2i.adr','c','query exists') <> "" then do
		Say 'NOTE! An existing MR/2 ICE address book, "'MR2PATH'\mr2i.adr",'
		Say 'was found.  New converted data will be APPENDED to this file'
		Say 'unless it is first deleted from the command line.'
		Say ''
	end

	if stream(MR2PATH'\mr2i.grp','c','query exists') <> "" then do
		Say 'NOTE! An existing MR/2 ICE Group file, "'MR2PATH'\mr2i.grp",'
		Say 'was found.  New converted data will be APPENDED to this file'
		Say 'unless it is first deleted from the command line.'
		Say ''
	end

	fOK = 0
	do while fOK = 0
		Say 'Address Book entries are converted to one of two forms:'
		Say ''
		Say '    1 - user@domain.com (John Doe)'
		Say '    2 - "John Doe" <user@domain.com>'
		Say ''
		Say 'Please select your preference by entering 1 or 2 and ENTER:'
		choice = linein()
		Say ''
		if choice = 1 then do
			RealNameInQuotes = 0
			fOK = 1
		end
		else if choice = 2 then do
			RealNameInQuotes = 1
			fOK = 1
		end
		else do
			Say ''
			Say 'Invalid selection!  Please select a 1 or 2, or CTR-C to abort.'
			Say ''
			Say ''
		end
	end

	'cd tools'

	books = 'BOOKS.DB'
	addresses = 'ADDR.DB'
	mr2groups = 'mr2i.grp'
	mr2addresses = 'mr2i.adr'

	'del 'mr2groups' >nul 2>nul'
	'del 'mr2addresses' >nul 2>nul'

	blank = ''
	crlf='0a'x              /* Set Carriage Return with LineFeed */

	status = stream(books,'c','open read')

	bctr = 0
	actr = 0
	groupctr = 0
	entryctr = 0
	do while lines(books) > 0
		bookentry = linein(books)
		Parse VALUE bookentry with name '' order '' field '' booknbr ''

		groupctr = groupctr + 1

		rc = lineout(mr2groups,'!G'||groupctr||'\'name'\N')

		abgroup = name||"\"

		Say 'Migrating Address Book "'name'" ...'

		status = stream(addresses,'c','open read')
		do while lines(addresses) > 0
			actr = actr + 1
			entryctr = entryctr + 1
			addr = linein(addresses)
			Parse VALUE addr with email '' alias '' realname '' fpopup '' company '' title '' rest
			Parse VALUE rest with hstreet '' hbldg '' hcity '' hstate '' hzip '' hphone '' hext '' hfax '' rest
			Parse VALUE rest with bstreet '' bbldg '' bcity '' bstate '' bzip '' bphone '' bext '' bfax '' notes '' book ''

			if alias = blank & MakeUpAliases = 1 then
				alias = 'A'||d2c(actr)

			finbook = 0
			rest = book

			do while rest <> ""
				parse value rest with bnbr ';' rest
				if bnbr = booknbr then
					finbook = 1
			end

			if finbook <> 0 then do
/*			  Say email' ('realname') 'alias */
				business = ''
				home = ''
				notes = ''

				if title <> blank then
					business = business||title||crlf
				if company <> blank then
					business = business||company||crlf
				if bstreet <> blank then do
					business = business||bstreet
					if bbldg <> blank then
						business = business||' '||bbldg
					business = business||crlf
				end

				if bcity <> blank | bstate <> blank | bzip <> blank then
					business = business||bcity', 'bstate'  'bzip||crlf
				if bphone <> blank then do
					business = business||crlf'Phone: 'bphone
					if bext <> blank then
						business = business' x'bext
					if bfax <> blank then
						business = business'   Fax: 'bfax
					business = business||crlf
				end

				if hstreet <> blank then do
					home = home||hstreet
					if hbldg <> blank then
						home = home||' '||hbldg
					home = home||crlf
				end

				if hcity <> blank | hstate <> blank | hzip <> blank then
					home = home||hcity', 'hstate'  'hzip||crlf
				if hphone <> blank then do
					home = home||crlf'Phone: 'hphone
					if hext <> blank then
						home = home' x'hext
					if hfax <> blank then
						home = home'   Fax: 'hfax
					home = home||crlf
				end

				if alias <> blank then do
					rc =lineout(mr2groups,'+'alias)
					abgroup = abgroup||alias||','
					if (RealNameInQuotes = 1) then
						rc = lineout(mr2addresses,realname'\"'realname'" <'email'>\N\'alias)
					else rc = lineout(mr2addresses,realname'\'email' ('realname')\N\'alias)
				end
				else do
					rc = lineout(mr2groups,'+'email)
					abgroup = abgroup||email||','
					if (RealNameInQuotes = 1) then
						rc = lineout(mr2addresses,realname'\"'realname'" <'email'>\N\I'||c2d(actr))
					else rc = lineout(mr2addresses,realname'\'email' ('realname')\N\I'||c2d(actr))
				end

				total = length(business) + length(home) + length(notes)
				if length(business) > 2 then
					total = total + 10
				if length(home) > 2 then
					total = total + 6
				if length(notes) > 2 then
					total = total + 7

				if (total > 6) then
					rc = lineout(mr2addresses,d2c(1)||total)

				if length(business) > 2 then
					rc = lineout(mr2addresses,'Business:'crlf||business)
				if length(home) > 2 then
					rc = lineout(mr2addresses,'Home:'crlf||home)
				if length(notes) > 2 then
					rc = lineout(mr2addresses,'Notes:'crlf||notes)
				if (total > 6) then
					rc = lineout(mr2addresses,'')
			end
		end

		status = stream(addresses,'c','close')

		if length(abgroup) > 0 then do
			abgroup = substr(abgroup,1,length(abgroup)-1)
			if length(abgroup) < 4096 then do
				abgroup = abgroup'\N\A'||groupctr
				rc = lineout(mr2addresses,abgroup)
			end
		end

		bctr = bctr + 1
	end

	status = stream(books,'c','close')
	status = stream(mr2groups,'c','close')
	status = stream(mr2addresses,'c','close')


	'copy 'MR2PATH'\mr2i.adr 'MR2PATH'\mr2iadr.000 >nul 2>nul'
	'copy 'MR2PATH'\mr2i.grp 'MR2PATH'\mr2igrp.000 >nul 2>nul'
	'copy mr2i.adr+'MR2PATH'\mr2i.adr 'MR2PATH'\mr2iadr.new >nul 2>nul'
	'copy mr2i.grp+'MR2PATH'\mr2i.grp 'MR2PATH'\mr2igrp.new >nul 2>nul'
	'copy 'MR2PATH'\mr2iadr.new 'MR2PATH'\mr2i.adr >nul 2>nul'
	'copy 'MR2PATH'\mr2igrp.new 'MR2PATH'\mr2i.grp >nul 2>nul'
	'del 'MR2PATH'\mr2iadr.new >nul 2>nul'
	'del 'MR2PATH'\mr2igrp.new >nul 2>nul'

	'cd ..'

end


if ConvertFolders = 0 then
	return 0

/* Do folders */

Say ''
Say 'Folders:'
Say ''

'mkdir 'MR2ACCTPATH' >nul 2>nul'
'cd pmmail'
'cd 'ACCT
'dir /B /S *.fld >dir.lst'

status = stream('dir.lst','c','open read')
status = stream(MR2ACCTPATH'\folders.ndx','c','open write')

bctr = 0
actr = 0
groupctr = 0
entryctr = 0
seq = 900
do while lines('dir.lst') > 0
	dir = linein('dir.lst')
	'cd 'dir

	rest = linein('folder.ini')
	status = stream('folder.ini','c','close')
	parse value rest with foldername '' rest

	prefix = dir
	o = lastpos('.FLD\',prefix)
	do while o > 0 then
		prefix = substr(prefix,1,o+3)
		'cd 'prefix
		rest = linein('folder.ini')
		status = stream('folder.ini','c','close')
		folderpref = '?'
		parse value rest with folderpref '' rest
		foldername = folderpref'-'foldername
		o = lastpos('.FLD\',prefix)
	end

	'cd 'dir

	Say 'Migrating folder "'foldername'" ... '

	if pos('INBOX.FLD',dir) > 0 then do
		'copy *.msg 'MR2ACCTPATH'\*.rcv >nul 2>nul'
		MR2PATH'\reindex 'MR2ACCTPATH' mr2i.ndx *.rcv >nul'
	end
	else if pos('SENT.FLD',dir) > 0 then do
		'copy *.snt 'MR2ACCTPATH'\*.out >nul 2>nul'
		'copy *.msg 'MR2ACCTPATH'\*.out >nul 2>nul'
		MR2PATH'\reindex 'MR2ACCTPATH' mr2i.out *.out >nul'
	end
	else if pos('OUTBOX.FLD',dir) > 0 then do
		'copy *.snt 'MR2ACCTPATH'\*.out >nul 2>nul'
		'copy *.msg 'MR2ACCTPATH'\*.out >nul 2>nul'
		MR2PATH'\reindex 'MR2ACCTPATH' mr2i.out *.out >nul'
	end
	else if pos('TRASH.FLD',dir) > 0 then do
		Say '  (nope ... leaving the trash where it sits!)'
	end
	else do
		status = lineout(MR2ACCTPATH'\folders.ndx',foldername''foldername'F'seq'N0')

		'mkdir 'MR2ACCTPATH'\F'seq
		'copy *.msg 'MR2ACCTPATH'\F'seq'\*.rcv >nul 2>nul'
		'copy *.snt 'MR2ACCTPATH'\F'seq'\*.out >nul 2>nul'
		MR2PATH'\reindex 'MR2ACCTPATH'\F'seq' folder.ndx *.rcv *.out >nul'
		seq = seq + 1
	end

	'cd 'basedir'\pmmail\'acct
end
status = stream('dir.lst','c','close')
status = stream(MR2ACCTPATH'\folders.ndx','c','close')

'cd ..'
'cd ..'

return 0
